unit uMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, IdIOHandler,
  IdIOHandlerSocket, IdIOHandlerStack, IdSSL, IdSSLOpenSSL,
  Vcl.Imaging.pngimage, Vcl.ExtCtrls;

type
  TForm23 = class(TForm)
    TitleEdit: TEdit;
    Button1: TButton;
    IdHTTP1: TIdHTTP;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    Memo1: TMemo;
    Button2: TButton;
    IOSTokenEDIT: TEdit;
    AndroidTokenEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    Label3: TLabel;
    Label4: TLabel;
    BodyEdit: TEdit;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  public
    procedure SendPushAndroid(aTitle: string; aBody: string);
    procedure SendPushIOS(aTitle: string; aBody: string);
    procedure iOSTokenBatchImport;
  end;

var
  Form23: TForm23;

CONST
  FIREBASE_AUTH_KEY = 'AAAAynMH4PQ:APA91bEVMvZS0Yo8Gi7P_4zGjl90MJxFlragqnHa8LCPtfWcxRDqNEodKWsJc0f7LTRA142DkZsn2XGN1NRCkXJo3xeeuIwEg-ONDebv9wj4nNY3Ewb5K8mFlLMn77ofjAmcI5uIFh8D';

implementation

{$R *.dfm}

procedure TForm23.Button1Click(Sender: TObject);
begin
  if AndroidTokenEdit.Text='' then raise Exception.Create('Please Insert Android Token');

  SendPushAndroid(TitleEdit.Text,BodyEdit.Text);
end;

procedure TForm23.Button2Click(Sender: TObject);
begin
  if iosTokenEdit.Text='' then raise Exception.Create('Please Insert iOS Token');

  SendPushIOS(TitleEdit.Text,BodyEdit.Text);
end;

procedure TForm23.Button3Click(Sender: TObject);
begin
  iOSTokenBatchImport;
end;

procedure TForm23.iOSTokenBatchImport;
var
  LIdHttp: TIdHttp;
  LIdIOHandler: TIdSSLIOHandlerSocketOpenSSL;
  jsonString: string;
  JsonToSend: TStringStream;
  response: string;
begin
  LIdHTTP := TIdHTTP.Create(nil);
  try
    LIdIOHandler := TIdSSLIOHandlerSocketOpenSSL.Create(LIdHTTP);
    LIdIOHandler.SSLOptions.Method := sslvSSLv23;
    LIdHTTP.IOHandler := LIdIOHandler;

    LIdHTTP.Request.ContentType := 'application/json';
    LIdHTTP.Request.Charset := 'UTF-8';
    // IMPOSTARE LA CHIAVE DI AUTORIZZAZIONE PER PARLARE CON FIREBASE
    // LA CHIAVE SI RECUPERA DAL PROGETTO CREATO IN FIREBASE
    LIdHTTP.Request.CustomHeaders.Values['Authorization'] := 'key='+FIREBASE_AUTH_KEY;

    jsonString := '{'+
                  '"application": "it.dnasoftware.delphiday2019",'+
                  '"sandbox":true,'+
                  '"apns_tokens":['+
                  '"'+iOSTokenEdit.Text+'"'+
                  ']'+
                  '}';

    JsonToSend := TStringStream.Create(jsonString, TEncoding.UTF8);
    try
      response := LIdHTTP.Post('https://iid.googleapis.com/iid/v1:batchImport', JsonToSend);
      response := response.Replace(#10, '');
    except
      on E: EIdHTTPProtocolException do
        response := e.ErrorMessage;
    end;
    Memo1.Lines.Insert(0, response);
  finally
    LIdHTTP.Free;
  end;
end;

procedure TForm23.SendPushAndroid(aTitle: string; aBody: string);
var
  LIdHttp: TIdHttp;
  LIdIOHandler: TIdSSLIOHandlerSocketOpenSSL;
  jsonString: string;
  JsonToSend: TStringStream;
  response: string;
begin
  LIdHTTP := TIdHTTP.Create(nil);
  try
    LIdIOHandler := TIdSSLIOHandlerSocketOpenSSL.Create(LIdHTTP);
    LIdIOHandler.SSLOptions.Method := sslvSSLv23;
    LIdHTTP.IOHandler := LIdIOHandler;

    LIdHTTP.Request.ContentType := 'application/json';
    LIdHTTP.Request.Charset := 'UTF-8';
    // IMPOSTARE LA CHIAVE DI AUTORIZZAZIONE PER PARLARE CON FIREBASE
    // LA CHIAVE SI RECUPERA DAL PROGETTO CREATO IN FIREBASE
    LIdHTTP.Request.CustomHeaders.Values['Authorization'] := 'key='+FIREBASE_AUTH_KEY;

    jsonString := '{"to" : "'+AndroidTokenEdit.Text+'",' +
               '"data" : {' +
                '"gcm.notification.body" : "'+aBody+'",' +
                '"colore" : "'+'rosso'+'",' +
                '"gcm.notification.title" : "'+aTitle+'"}}';

    JsonToSend := TStringStream.Create(jsonString, TEncoding.UTF8);
    try
      response := LIdHTTP.Post('https://fcm.googleapis.com/fcm/send', JsonToSend);
      response := response.Replace(#10, '');
    except
      on E: EIdHTTPProtocolException do
        response := e.ErrorMessage;
    end;
    Memo1.Lines.Insert(0, response);
  finally
    LIdHTTP.Free;
  end;
end;

procedure TForm23.SendPushIOS(aTitle: string; aBody: string);
var
  LIdHttp: TIdHttp;
  LIdIOHandler: TIdSSLIOHandlerSocketOpenSSL;
  jsonString: string;
  JsonToSend: TStringStream;
  response: string;
begin
  LIdHTTP := TIdHTTP.Create(nil);
  try
    LIdIOHandler := TIdSSLIOHandlerSocketOpenSSL.Create(LIdHTTP);
    LIdIOHandler.SSLOptions.Method := sslvSSLv23;
    LIdHTTP.IOHandler := LIdIOHandler;

    LIdHTTP.Request.ContentType := 'application/json';
    LIdHTTP.Request.Charset := 'UTF-8';
    // IMPOSTARE LA CHIAVE DI AUTORIZZAZIONE PER PARLARE CON FIREBASE
    // LA CHIAVE SI RECUPERA DAL PROGETTO CREATO IN FIREBASE
    LIdHTTP.Request.CustomHeaders.Values['Authorization'] := 'key='+FIREBASE_AUTH_KEY;

//       jsonString := '{"to" : "'+IOSTokenEdit.Text+'",' +
//                   '"notification" : {' +
//                    '"body" : "'+'body'+'",' +
//                    '"title" : "'+'title'+'",' +
//                    '"badge" : "'+'0'+'"},' +
//                   '"data" : {' +
//                    '"body" : "'+'body'+'",' +
//                    '"colore" : "'+'rosso'+'",' +
//                    '"title" : "'+'title'+'"}' +
//                    '"content_available": false }';

       jsonString := '{"to" : "'+IOSTokenEdit.Text+'",' +
                   '"notification" : {' +
                    '"body" : "'+aBody+'",' +
                    '"title" : "'+aTitle+'",' +
                    '"badge" : "'+'0'+'"},' +
                    '"data" : {' +
                    '    "score": "15"'+
                    '},' +
                    '"content_available": true }';

    JsonToSend := TStringStream.Create(jsonString, TEncoding.UTF8);
    try
      response := LIdHTTP.Post('https://fcm.googleapis.com/fcm/send', JsonToSend);
      response := response.Replace(#10, '');
    except
      on E: EIdHTTPProtocolException do
        response := e.ErrorMessage;
    end;
    Memo1.Lines.Insert(0, response);
  finally
    LIdHTTP.Free;
  end;
end;

end.
