unit Errors;

interface

Type
  TLogType = class
  public
    class procedure LogError(const aError, aPosition: String);
    class procedure LogDebug(const aValue, aPosition: String);
  end;

implementation

uses LoggerProConfig, System.SysUtils;

{ TErrorType }

class procedure TLogType.LogError(const aError, aPosition: String);
begin
  log.ErrorFmt('Error: %s', [aError], aPosition);
  raise exception.create(aError);
end;

class procedure TLogType.LogDebug(const aValue, aPosition: String);
begin
  log.DebugFmt('Value: %s', [aValue], aPosition);
end;

end.
