unit Server.Authentication;

interface

uses
  System.SysUtils,
  System.Generics.Collections,
  MVCFramework.Commons,
  MVCFramework;

type
  TAuthenticationHandler = class(TInterfacedObject, IMVCAuthenticationHandler)
  protected
    // IMVCAuthenticationHandler
    procedure OnRequest(const AContext: TWebContext; const AControllerQualifiedClassName, AActionName: string;
      var AAuthenticationRequired: Boolean);
    procedure OnAuthentication(const AContext: TWebContext; const AUserName, APassword: string;
      AUserRoles: TList<string>; var AIsValid: Boolean; const ASessionData: TDictionary<string, string>);
    procedure OnAuthorization(const AContext: TWebContext; AUserRoles: TList<string>;
      const AControllerQualifiedClassName: string; const AActionName: string; var AIsAuthorized: Boolean);
  end;

implementation

uses
  MVCFramework.JWT,
  System.NetEncoding,
  Service.Services;

{ TMVCAuthorization }

procedure TAuthenticationHandler.OnAuthentication(const AContext: TWebContext; const AUserName, APassword: string;
      AUserRoles: TList<string>; var AIsValid: Boolean; const ASessionData: TDictionary<string, string>);
var
  OUserId: Integer;
begin
  //*-------------------------------------------------------------------------------*
  //* Questo metodo viene chiamato per capire se l'utente  autenticato nel sistema *
  //*-------------------------------------------------------------------------------*
  AIsValid := True;
  ASessionData.Add('userid',OUserId.ToString);
end;

procedure TAuthenticationHandler.OnAuthorization
  (const AContext: TWebContext; AUserRoles: TList<string>;
      const AControllerQualifiedClassName: string; const AActionName: string; var AIsAuthorized: Boolean);
begin
  AIsAuthorized := True;
end;

procedure TAuthenticationHandler.OnRequest(const AContext: TWebContext; const AControllerQualifiedClassName, AActionName: string;
      var AAuthenticationRequired: Boolean);
begin
  AAuthenticationRequired := False;
end;

end.

