unit Model.BusinessObjects;

interface

uses
  MVCFramework.Serializer.Commons;

type
  TBaseBO = class
  private
    FID: Integer;
    procedure SetID(const Value: Integer);
  public
    procedure CheckInsert; virtual;
    procedure CheckUpdate; virtual;
    procedure CheckDelete; virtual;
    property ID: Integer read FID write SetID;
  end;

  [MVCNameCase(ncLowerCase)]
  TDevice = class(TBaseBO)
  private
    FDeviceToken: string;
    FExternalId: string;
    FDescription: string;
    FDeviceId: string;
    FDeviceType: string;
    FDeviceOs: string;
    FDeviceOsVersion: string;
    FDeviceModel: string;
    FMailAddress: string;
    procedure SetDescription(const Value: string);
    procedure SetDeviceId(const Value: string);
    procedure SetDeviceToken(const Value: string);
    procedure SetExternalId(const Value: string);
    procedure SetDeviceOs(const Value: string);
    procedure SetDeviceOsVersion(const Value: string);
    procedure SetDeviceType(const Value: string);
    procedure SetDeviceModel(const Value: string);
    procedure SetMailAddress(const Value: string);
  public
    procedure CheckInsert; override;
    procedure CheckUpdate; override;
    procedure CheckDelete; override;
    [MVCColumn('DEVICEID')]
    property DeviceId: string read FDeviceId write SetDeviceId;
    [MVCColumn('DEVICETOKEN')]
    property DeviceToken: string read FDeviceToken write SetDeviceToken;
    [MVCColumn('DESCRIPTION')]
    property Description: string read FDescription write SetDescription;
    [MVCColumn('EXTERNALID')]
    property ExternalId: string read FExternalId write SetExternalId;
    [MVCColumn('DEVICETYPE')]  // 0=ios, 1=Android
    property DeviceType: string read FDeviceType write SetDeviceType;
    [MVCColumn('DEVICEOS')]
    property DeviceOs: string read FDeviceOs write SetDeviceOs;
    [MVCColumn('DEVICEOSVERSION')]
    property DeviceOsVersion: string read FDeviceOsVersion write SetDeviceOsVersion;
    [MVCColumn('DEVICEMODEL')]
    property DeviceModel: string read FDeviceModel write SetDeviceModel;
    [MVCColumn('MAILADDRESS')]
    property MailAddress: string read FMailAddress write SetMailAddress;
  end;

implementation

uses
  System.SysUtils,
  System.RegularExpressions;

{ TBaseBO }

procedure TBaseBO.CheckDelete;
begin

end;

procedure TBaseBO.CheckInsert;
begin

end;

procedure TBaseBO.CheckUpdate;
begin

end;

procedure TBaseBO.SetID(const Value: Integer);
begin
  FID := Value;
end;


{ TDevice }

procedure TDevice.CheckDelete;
begin
  inherited;

end;

procedure TDevice.CheckInsert;
begin
  inherited;

end;

procedure TDevice.CheckUpdate;
begin
  inherited;

end;

procedure TDevice.SetDescription(const Value: string);
begin
  FDescription := Value;
end;

procedure TDevice.SetDeviceId(const Value: string);
begin
  FDeviceId := Value;
end;

procedure TDevice.SetDeviceModel(const Value: string);
begin
  FDeviceModel := Value;
end;

procedure TDevice.SetDeviceOs(const Value: string);
begin
  FDeviceOs := Value;
end;

procedure TDevice.SetDeviceOsVersion(const Value: string);
begin
  FDeviceOsVersion := Value;
end;

procedure TDevice.SetDeviceToken(const Value: string);
begin
  FDeviceToken := Value;
end;

procedure TDevice.SetDeviceType(const Value: string);
begin
  FDeviceType := Value;
end;

procedure TDevice.SetExternalId(const Value: string);
begin
  FExternalId := Value;
end;

procedure TDevice.SetMailAddress(const Value: string);
begin
  FMailAddress := Value;
end;


end.

